// Creates a new object and uses object.seal to restrict it
var obj = {};
obj.greeting = 'Welcome';
Object.seal(obj);
//Updating the existing writable property
//Cannot convert existing property to accessor, throws TypeErrors
obj.greeting = 'Hello World';
Object.defineProperty(obj, 'greeting', {get:function(){return 'Hello World'; } });
// Cannot delete property, fails silently
delete obj.greeting;
Chapter 2 ■ Features, Functions, and Objects
14
function makeTypeError(){
'use strict';
//Generates TypeError when trying to delete a property
delete obj.greeting;
//Can still update property
obj.greeting = 'Welcome';
console.log(obj.greeting);
}
makeTypeError();
