//Creates a new object with two properties. Second property is an object
var obj = {
greeting: "Welcome",
innerObj: {}
};
//Freeezes our obj
Object.freeze(obj);
//silently fails
obj.greeting = 'Hello World';
//innerObj can still be updated
obj.innerObj.greeting = 'Hello World';
console.log('obj.innerObj.greeting = ' + obj.innerObj.greeting);
//Cannot convert existing property to accessor
//Throws TypeError
Object.defineProperty(obj, 'greeting', {get:function(){return 'Hello World'; } });
// Cannot delete property, fails silently
delete obj.greeting;
function makeTypeError(){
'use strict';
}
//Generates TypeError when trying to delete a property
delete obj.greeting;
Chapter 2 ■ Features, Functions, and Objects
15
//Freeze inner object
Object.freeze(obj.innerObj);
//innerObj is now frozen. Fails silently
obj.innerObj.greeting = 'Worked so far...';
function makeTypeError(){
'use strict';
//all attempts will throw TypeErrors
delete obj.greeting;
obj.innerObj.greeting = 'Worked so far...';
obj.greeting = "Welcome";
};
makeTypeError();
