function getModule() {
// Namespaces example
var FOO = {};
// Add a variable
FOO.x = 10;
// Add a function
FOO.addEmUp = function ( x, y ) {
return x + y;
};
// A private variable
var events = [];
FOO.addEvent = function(eventName, target, fn) {
events.push({eventName: eventName, target: target, fn: fn});
};
FOO.listEvents = function(eventName) {
return events.filter(function(evtObj) {
return evtObj.eventName === eventName
});
};
return FOO;
}
var myNamespace = getModule();
