// Here, the $ refers to jQuery and jQuery only for the entire
// scope of the module
var myModule = (function ($) {
// A private variable
var events = [];
return {
x : 10,
addEmUp : function ( x, y ) {
return x + y;
},
addEvent : function ( eventName, target, fn ) {
events.push( {eventName : eventName, target : target, fn : fn} );
$( target ).on( eventName, fn );
},
listEvents : function ( eventName ) {
return events.filter( function ( evtObj ) {
return evtObj.eventName === eventName
} );
}
};
})(jQuery); // Assumes that we had included jQuery earlier
