var Person = {
firstName : 'John',
lastName : 'Connolly',
birthDate : new Date( '1964-09-05' ),
gender : 'male',
getAge : function () {
var today = new Date();
var diff = today.getTime() - this.birthDate.getTime();
var year = 1000 * 60 * 60 * 24 * 365.25;
return Math.floor( diff / year );
},
toString : function () {
return this.firstName + ' ' + this.lastName + ' is a ' + this.getAge() +
' year-old ' + this.gender;
},
extend : function ( config ) {
var tmp = Object.create( this );
for ( var key in config ) {
if ( config.hasOwnProperty( key ) ) {
tmp[key] = config[key];
}
}
// When was this object created?
var creationTime = new Date();
// An accessor, at the moment, it's private
var getCreationTime = function() {
return creationTime;
};
tmp.getCreationTime = getCreationTime;
return tmp;
}
};
var Teacher = Person.extend( {
job : 'teacher',
subject : 'English Literature',
yearsExp : 5,
toString : function () {
var originalStr = Person.toString.call(this);
return originalStr + ' ' + this.subject + ' teacher.';
}
} );
var patty = Teacher.extend( {
firstName : 'Patricia',
lastName : 'Hannon',
subject: 'chemistry',
yearsExp : 20,
gender : 'female'
} );
console.log( patty.toString() );
console.log( 'The Teacher object was created at %s', patty.getCreationTime() );
