// Wait until the DOM is Ready
document.addEventListener('DOMContentLoaded', addEventClickToTerms);
// Watch for a user click on the term
function addEventClickToTerms(){
var dt = document.getElementsByTagName('dt');
for ( var i = 0; i < dt.length; i++ ) {
dt[i].addEventListener('click', checkIfOpen);
}
}
// See if the definition is already open or not
//Need two nextSiblings because the first sibling is a text node (the words that were clicked on).
//If it's never been clicked, the style will be blank ''. F it has been, the style will be 'none', so we check for both with an if statement.
function checkIfOpen(e){
if(e.target.nextSibling.nextSibling.style.display == '' || e.target.nextSibling.nextSibling.style.display == 'none'){
e.target.nextSibling.nextSibling.style.display = 'block';
}else{
e.target.nextSibling.nextSibling.style.display = 'none';
}
}
