// A simple filtering function
// An Element's nodeName property is always the name of the underlying tag.
function filterForListItems(el) {
return el.nodeName === 'LI';
}
var testElements = document.getElementsByClassName( 'test' );
console.log( 'There are ' + testElements.length + ' elements in testElements.');
// Generating an array from the elements gathered from testElements
// based on whether they pass the filtering proccess set up by filterForListItems
var liElements = Array.prototype.filter.call(testElements, filterForListItems);
console.log( 'There are ' + liElements.length + ' elements in liElements.');
