var myRequest = new XMLHttpRequest();
myRequest.addEventListener('loadstart', onLoadStart, false);
myRequest.addEventListener('progress', onProgress, false);
myRequest.addEventListener('load', onLoad, false);
myRequest.addEventListener('error', onError, false);
myRequest.addEventListener('abort', onAbort, false);
//Must add eventListeners before running a send or open method
myRequest.open('GET', '/fileOnServer');

function onLoadStart(evt){
console.log('starting the request');
}
function onProgress(evt){
var currentPercent = (evt.loaded / evt.total) * 100;
console.log(currentPercent);
}
function onLoad(evt){
console.log('transfer is complete');
}
function onError(evt){
console.log('error during transfer');
}
function onAbort(evt){
console.log('the user aborted the transfer');
}
